#ifndef __CONNECTION_H_
#define __CONNECTION_H_

#include "ocicpp.h"
#include "Cursor.h"

class Connection {
private:
	OCIEnv *envhp;
	OCIServer *srvhp;
	OCIError *errhp;
	OCISvcCtx *svchp;
	OCISession *authp;
	OCITrans *trans; /* Only one transaction allowed per connection */
	sword status;
public:
	Connection();
	Connection(OCIEnv *env,const string &tnsname,const string &user,const string &password);
	~Connection(); 
	void drop();
	void init(OCIEnv *env,const string &tnsname,const string &user,const string &password); 
	/* Obsolete should not be used. Use void execQuery(const string &,Cursor &) insteed */
	Cursor *execQuery(const string &);
	void execQuery(const string &,Cursor &);
	void execUpdate(const string &);
	void transStart(int flags=SERIALIZABLE);
	void transCommit();
	void transRollback();
};





#endif