#define __OCICPP_INTERNAL_USE_
#include "OraLob.h"


OraLob::OraLob(OCIEnv *envhp,OCIError *errhp,OCIParam *param,OCISvcCtx *svc,ub2 lob_type): 
				OraType(envhp,errhp,param,lob_type),lob(0),svchp(svc),type(lob_type)
{
	ReqType=lob_type;
	size=0;
	if(OCIDescriptorAlloc((void *)envhp,(void **)&lob,OCI_DTYPE_LOB,0,0)!=OCI_SUCCESS) {
		throw new OraError("OCICPPLIB: Cannot make new LOB: Handle Allocation failed",OCICPPERROR);
	}
	
}

OraLob::~OraLob() {
	OCIDescriptorFree(lob,OCI_DTYPE_LOB);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);
}

void OraLob::define(OCIStmt *stmt,int col) {
	 CHECKERR(err, OCIDefineByPos(stmt,&definehp, err, col+1, &lob, -1,ReqType,
	                                (dvoid *) &null, 0, (ub2 *)0, OCI_DEFAULT)); 
}

void OraLob::getCLOB(Lob &ulob) {
	ulob.init(svchp,lob,err,CLOB,CACHE_OFF);
}

void OraLob::getBLOB(Lob &ulob) {
	ulob.init(svchp,lob,err,BLOB,CACHE_OFF);
}

void OraLob::getStr(string &str) {
	str.assign(typeName);
}