#define __OCICPP_INTERNAL_USE_
#include "OraNumber.h"

OraNumber::OraNumber(OCIEnv *envhp,OCIError *errhp,OCIParam *paramd,ub2 type): OraType(envhp,errhp,paramd,type),data(0) {
	ub2 prec; /* There's a bug in documentation it should be ub2 */
	ReqType=SQLT_STR;
	OCIAttrGet((dvoid *) paramd,OCI_DTYPE_PARAM,(dvoid *) &prec,(ub4 *) 0,(ub4) OCI_ATTR_PRECISION,errhp);
	if(!prec) size=255;
	else size=(unsigned)prec;
	data=(char *)calloc(size+1,sizeof(char));
	DEBUG(DLEV_FATAL,"Size=%d\n",size);
}

OraNumber::~OraNumber() {
	free(data);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);	
}

void OraNumber::define(OCIStmt *stmt,int col) {
	DEBUG(DLEV_DEBUG,"Defining ...\n");
	CHECKERR(err, OCIDefineByPos(stmt,&definehp, err, col+1, data, size+1,ReqType,
	                               (dvoid *) &null, 0, (ub2 *)0, OCI_DEFAULT));	
}
	
void OraNumber::getStr(string &str) {
	if(data) str.assign(data);
	else throw new OraError("OCICPPLIB: Cannot getStr: Not fetched yet",OCICPPERROR);
}

void OraNumber::getInt(int &val) {
	if(data) {
		val=atoi(data);
		return;
	} else throw new OraError("OCICPPLIB: Cannot getInt: Not fetched yet",OCICPPERROR);
}

void OraNumber::getDouble(double &val) {
	if(data) {
		val=atof(data);
		return;
	} else throw new OraError("OCICPPLIB: Cannot getDouble: Not fetched yet",OCICPPERROR);
}


		

	