#define __OCICPP_INTERNAL_USE_

#include "OraString.h"

OraString::OraString(OCIEnv *envhp,OCIError *errhp,OCIParam *paramd,ub2 type) : 
				OraType(envhp,errhp,paramd,type),data(0)
{
	DEBUG(DLEV_DEBUG,"Constructing OraString\n");
	ub2 colSize;
	ReqType=SQLT_STR; /* Request a Null-terminating string for all types */
	CHECKERR(errhp,OCIAttrGet((dvoid *) paramd,OCI_DTYPE_PARAM,(dvoid *) &colSize,(ub4 *) 0,(ub4) OCI_ATTR_DATA_SIZE,errhp));
	size=(unsigned)(colSize?colSize:4000); /* For LONG */
	data=(char *)calloc(size+1,sizeof(char));
	DEBUG(DLEV_DEBUG,"ColName:%s ColType:%s ColSize:%d\n",attrName.c_str(),typeName.c_str(),colSize);
}

OraString::~OraString() {
	free(data);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);
}

void OraString::getStr(string &str) {
	if(data) str.assign(data);
	else throw new OraError("OCICPPLIB: Cannot getStr: Not fetched yet",OCICPPERROR);
}

void OraString::define(OCIStmt *stmt,int col) {
	 CHECKERR(err, OCIDefineByPos(stmt, &definehp, err, col+1, data, size+1,ReqType,
	                                (dvoid *) &null, 0, (ub2 *)0, OCI_DEFAULT));
}