#ifndef __ORATYPE_H_
#define __ORATYPE_H_

#include "ocicpp.h"
#include "OraError.h"

class OraType {
protected:
	OCIDefine *definehp;
	OCIEnv    *env;
	OCIError  *err;
	string attrName; /* Attribute name this cell belongs to */
	string typeName; /* Type name e.g. varchar2 or CLOB or NUMBER */
	ub2 internalType; /* Oracle internal type e.g. number varchar2 and so on */
	ub2 ReqType; /* Requested type e.g. string for number and so on */
	unsigned size; /* Size e.g. len for LOB */
	sb2 null;
protected:
	virtual void setTypeName();
public:
	OraType(OCIEnv *,OCIError *,OCIParam *,ub2);
	virtual ~OraType();
	virtual unsigned getSize() const;
	virtual int getType() const;
	virtual int getReqType() const;
	virtual void getTypeName(string &tname) const;
	virtual void getAttrName(string &aname) const;
	virtual int isNull() const;
	
public: 	
	virtual void getStr(string &) = 0;
	virtual void define(OCIStmt *,int) = 0;
};


#endif